doc: update suffix regex in version sort
[platform/upstream/coreutils.git] / maint.mk
1 # -*-Makefile-*-
2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by at least coreutils, idutils, CPPI, Bison, and Autoconf.
4
5 ## Copyright (C) 2001-2009 Free Software Foundation, Inc.
6 ##
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
11 ##
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 ## GNU General Public License for more details.
16 ##
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program.  If not, see <http://www.gnu.org/licenses/>.
19
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22 ME := maint.mk
23
24 # Do not save the original name or timestamp in the .tar.gz file.
25 # Use --rsyncable if available.
26 gzip_rsyncable := \
27   $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null && echo --rsyncable)
28 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
29
30 GIT = git
31 VC = $(GIT)
32 VC-tag = git tag -s -m '$(VERSION)'
33
34 VC_LIST = $(srcdir)/build-aux/vc-list-files
35
36 VC_LIST_EXCEPT = \
37   $(VC_LIST) | if test -f .x-$@; then grep -vEf .x-$@; else grep -v ChangeLog; fi
38
39 ifeq ($(origin prev_version_file), undefined)
40   prev_version_file = $(srcdir)/.prev-version
41 endif
42
43 PREV_VERSION := $(shell cat $(prev_version_file))
44 VERSION_REGEXP = $(subst .,\.,$(VERSION))
45 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
46
47 ifeq ($(VC),$(GIT))
48 this-vc-tag = v$(VERSION)
49 this-vc-tag-regexp = v$(VERSION_REGEXP)
50 else
51 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
52 tag-this-version = $(subst .,_,$(VERSION))
53 this-vc-tag = $(tag-package)-$(tag-this-version)
54 this-vc-tag-regexp = $(this-vc-tag)
55 endif
56 my_distdir = $(PACKAGE)-$(VERSION)
57
58 # Old releases are stored here.
59 release_archive_dir ?= ../release
60
61 # Prevent programs like 'sort' from considering distinct strings to be equal.
62 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
63 export LC_ALL = C
64
65 ## --------------- ##
66 ## Sanity checks.  ##
67 ## --------------- ##
68
69 # Collect the names of rules starting with `sc_'.
70 syntax-check-rules := $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
71                         $(srcdir)/$(ME) $(srcdir)/cfg.mk)
72 .PHONY: $(syntax-check-rules)
73
74 local-checks-available = \
75   patch-check $(syntax-check-rules) \
76   makefile-check check-AUTHORS
77 .PHONY: $(local-checks-available)
78
79 # Arrange to print the name of each syntax-checking rule just before running it.
80 $(syntax-check-rules): %: %.m
81 $(patsubst %, %.m, $(syntax-check-rules)):
82         @echo $(patsubst sc_%.m, %, $@)
83
84 local-check := $(filter-out $(local-checks-to-skip), $(local-checks-available))
85
86 syntax-check: $(local-check)
87 #       @grep -nE '#  *include <(limits|std(def|arg|bool))\.h>'         \
88 #           $$(find -type f -name '*.[chly]') &&                        \
89 #         { echo '$(ME): found conditional include' 1>&2;               \
90 #           exit 1; } || :
91
92 #       grep -nE '^#  *include <(string|stdlib)\.h>'                    \
93 #           $(srcdir)/{lib,src}/*.[chy] &&                              \
94 #         { echo '$(ME): FIXME' 1>&2;                                   \
95 #           exit 1; } || :
96 # FIXME: don't allow `#include .strings\.h' anywhere
97
98 # By default, _prohibit_regexp does not ignore case.
99 export ignore_case =
100 _ignore_case = $$(test -n "$$ignore_case" && echo -i || :)
101
102 # There are many rules below that prohibit constructs in this package.
103 # If the offending construct can be matched with a grep-E-style regexp,
104 # use this macro.  The shell variables "re" and "msg" must be defined.
105 define _prohibit_regexp
106   dummy=; : so we do not need a semicolon before each use               \
107   test "x$$re" != x || { echo '$(ME): re not defined' 1>&2; exit 1; };  \
108   test "x$$msg" != x || { echo '$(ME): msg not defined' 1>&2; exit 1; };\
109   grep $(_ignore_case) -nE "$$re" $$($(VC_LIST_EXCEPT)) &&              \
110     { echo '$(ME): '"$$msg" 1>&2; exit 1; } || :
111 endef
112
113 sc_avoid_if_before_free:
114         @$(srcdir)/build-aux/useless-if-before-free                     \
115                 $(useless_free_options)                                 \
116             $$($(VC_LIST_EXCEPT)) &&                                    \
117           { echo '$(ME): found useless "if" before "free" above' 1>&2;  \
118             exit 1; } || :
119
120 sc_cast_of_argument_to_free:
121         @re='\<free *\( *\(' msg='don'\''t cast free argument'          \
122           $(_prohibit_regexp)
123
124 sc_cast_of_x_alloc_return_value:
125         @re='\*\) *x(m|c|re)alloc\>'                                    \
126         msg='don'\''t cast x*alloc return value'                        \
127           $(_prohibit_regexp)
128
129 sc_cast_of_alloca_return_value:
130         @re='\*\) *alloca\>' msg='don'\''t cast alloca return value'    \
131           $(_prohibit_regexp)
132
133 sc_space_tab:
134         @re='[ ]        ' msg='found SPACE-TAB sequence; remove the SPACE' \
135           $(_prohibit_regexp)
136
137 # Don't use *scanf or the old ato* functions in `real' code.
138 # They provide no error checking mechanism.
139 # Instead, use strto* functions.
140 sc_prohibit_atoi_atof:
141         @re='\<([fs]?scanf|ato([filq]|ll)) *\('                         \
142         msg='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
143           $(_prohibit_regexp)
144
145 # Use STREQ rather than comparing strcmp == 0, or != 0.
146 sc_prohibit_strcmp:
147         @grep -nE '! *str''cmp *\(|\<str''cmp *\([^)]+\) *=='           \
148             $$($(VC_LIST_EXCEPT))                                       \
149           | grep -vE ':# *define STREQ\(' &&                            \
150           { echo '$(ME): use STREQ in place of the above uses of str''cmp' \
151                 1>&2; exit 1; } || :
152
153 # Using EXIT_SUCCESS as the first argument to error is misleading,
154 # since when that parameter is 0, error does not exit.  Use `0' instead.
155 sc_error_exit_success:
156         @grep -nE 'error \(EXIT_SUCCESS,'                               \
157             $$($(VC_LIST_EXCEPT) | grep -E '\.[chly]$$') &&             \
158           { echo '$(ME): found error (EXIT_SUCCESS' 1>&2; exit 1; } || :
159
160 # `FATAL:' should be fully upper-cased in error messages
161 # `WARNING:' should be fully upper-cased, or fully lower-cased
162 sc_error_message_warn_fatal:
163         @grep -nEA2 '[^rp]error \(' $$($(VC_LIST_EXCEPT))               \
164             | grep -E '"Warning|"Fatal|"fatal' &&                       \
165           { echo '$(ME): use FATAL, WARNING or warning' 1>&2;           \
166             exit 1; } || :
167
168 # Error messages should not start with a capital letter
169 sc_error_message_uppercase:
170         @grep -nEA2 '[^rp]error \(' $$($(VC_LIST_EXCEPT))               \
171             | grep -E '"[A-Z]'                                          \
172             | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' &&           \
173           { echo '$(ME): found capitalized error message' 1>&2;         \
174             exit 1; } || :
175
176 # Error messages should not end with a period
177 sc_error_message_period:
178         @grep -nEA2 '[^rp]error \(' $$($(VC_LIST_EXCEPT))               \
179             | grep -E '[^."]\."' &&                                     \
180           { echo '$(ME): found error message ending in period' 1>&2;    \
181             exit 1; } || :
182
183 sc_file_system:
184         @re=file''system ignore_case=1                                  \
185         msg='found use of "file''system"; spell it "file system"'       \
186           $(_prohibit_regexp)
187
188 # Don't use cpp tests of this symbol.  All code assumes config.h is included.
189 sc_prohibit_have_config_h:
190         @grep -n '^# *if.*HAVE''_CONFIG_H' $$($(VC_LIST_EXCEPT)) &&     \
191           { echo '$(ME): found use of HAVE''_CONFIG_H; remove'          \
192                 1>&2; exit 1; } || :
193
194 # Nearly all .c files must include <config.h>.
195 sc_require_config_h:
196         @if $(VC_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then          \
197           grep -L '^# *include <config\.h>'                             \
198                 $$($(VC_LIST_EXCEPT) | grep '\.c$$')                    \
199               | grep . &&                                               \
200           { echo '$(ME): the above files do not include <config.h>'     \
201                 1>&2; exit 1; } || :;                                   \
202         else :;                                                         \
203         fi
204
205 # You must include <config.h> before including any other header file.
206 sc_require_config_h_first:
207         @if $(VC_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then          \
208           fail=0;                                                       \
209           for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do             \
210             grep '^# *include\>' $$i | sed 1q                           \
211                 | grep '^# *include <config\.h>' > /dev/null            \
212               || { echo $$i; fail=1; };                                 \
213           done;                                                         \
214           test $$fail = 1 &&                                            \
215             { echo '$(ME): the above files include some other header'   \
216                 'before <config.h>' 1>&2; exit 1; } || :;               \
217         else :;                                                         \
218         fi
219
220 sc_prohibit_HAVE_MBRTOWC:
221         @re='\bHAVE_MBRTOWC\b' msg="do not use $$re; it is always defined" \
222           $(_prohibit_regexp)
223
224 # To use this "command" macro, you must first define two shell variables:
225 # h: the header, enclosed in <> or ""
226 # re: a regular expression that matches IFF something provided by $h is used.
227 define _header_without_use
228   h_esc=`echo "$$h"|sed 's/\./\\./'`;                                   \
229   if $(VC_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then                 \
230     files=$$(grep -l '^# *include '"$$h_esc"                            \
231              $$($(VC_LIST_EXCEPT) | grep '\.c$$')) &&                   \
232     grep -LE "$$re" $$files | grep . &&                                 \
233       { echo "$(ME): the above files include $$h but don't use it"      \
234         1>&2; exit 1; } || :;                                           \
235   else :;                                                               \
236   fi
237 endef
238
239 # Prohibit the inclusion of assert.h without an actual use of assert.
240 sc_prohibit_assert_without_use:
241         @h='<assert.h>' re='\<assert *\(' $(_header_without_use)
242
243 # Prohibit the inclusion of getopt.h without an actual use.
244 sc_prohibit_getopt_without_use:
245         @h='<getopt.h>' re='\<getopt(_long)? *\(' $(_header_without_use)
246
247 # Don't include quotearg.h unless you use one of its functions.
248 sc_prohibit_quotearg_without_use:
249         @h='"quotearg.h"' re='\<quotearg(_[^ ]+)? *\(' $(_header_without_use)
250
251 # Don't include quote.h unless you use one of its functions.
252 sc_prohibit_quote_without_use:
253         @h='"quote.h"' re='\<quote(_n)? *\(' $(_header_without_use)
254
255 # Don't include this header unless you use one of its functions.
256 sc_prohibit_long_options_without_use:
257         @h='"long-options.h"' re='\<parse_long_options *\(' \
258           $(_header_without_use)
259
260 # Don't include this header unless you use one of its functions.
261 sc_prohibit_inttostr_without_use:
262         @h='"inttostr.h"' re='\<(off|[iu]max|uint)tostr *\(' \
263           $(_header_without_use)
264
265 # Don't include this header unless you use one of its functions.
266 sc_prohibit_error_without_use:
267         @h='"error.h"' \
268         re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
269           $(_header_without_use)
270
271 sc_prohibit_safe_read_without_use:
272         @h='"safe-read.h"' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
273           $(_header_without_use)
274
275 sc_prohibit_argmatch_without_use:
276         @h='"argmatch.h"' \
277         re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<argmatch(_exit_fn|_(in)?valid) *\()' \
278           $(_header_without_use)
279
280 sc_prohibit_root_dev_ino_without_use:
281         @h='"root-dev-ino.h"' \
282         re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
283           $(_header_without_use)
284
285 # Prohibit the inclusion of c-ctype.h without an actual use.
286 ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
287 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
288 sc_prohibit_c_ctype_without_use:
289         @h='[<"]c-ctype.h[">]' re='\<c_($(ctype_re)) *\(' $(_header_without_use)
290
291 _empty =
292 _sp = $(_empty) $(_empty)
293 # The following list was generated by running:
294 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
295 #   | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
296 _sig_functions = \
297   bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
298   sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
299   siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
300   sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
301 _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
302 # The following were extracted from "man signal.h" manually.
303 _sig_types_and_consts =                                                 \
304   MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK           \
305   SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL            \
306   SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE    \
307   SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t  \
308   sigstack sigval stack_t ucontext_t
309 # generated via this:
310 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
311 _sig_names =                                                            \
312   SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT      \
313   SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL       \
314   SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP  \
315   SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR      \
316   SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS   \
317   SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1        \
318   SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW       \
319   SIGXCPU SIGXFSZ
320 _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
321
322 # Prohibit the inclusion of signal.h without an actual use.
323 sc_prohibit_signal_without_use:
324         @h='<signal.h>'                                                 \
325         re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>'          \
326           $(_header_without_use)
327
328 sc_obsolete_symbols:
329         @re='\<(HAVE''_FCNTL_H|O''_NDELAY)\>'                           \
330         msg='do not use HAVE''_FCNTL_H or O'_NDELAY                     \
331           $(_prohibit_regexp)
332
333 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
334
335 # Each nonempty line must start with a year number, or a TAB.
336 sc_changelog:
337         @grep -n '^[^12 ]' $$(find . -maxdepth 2 -name ChangeLog) &&    \
338           { echo '$(ME): found unexpected prefix in a ChangeLog' 1>&2;  \
339             exit 1; } || :
340
341 # Ensure that each .c file containing a "main" function also
342 # calls set_program_name.
343 sc_program_name:
344         @if $(VC_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then          \
345           files=$$(grep -l '^main *(' $$($(VC_LIST_EXCEPT) | grep '\.c$$')); \
346           grep -LE 'set_program_name *\(m?argv\[0\]\);' $$files         \
347               | grep . &&                                               \
348           { echo '$(ME): the above files do not call set_program_name'  \
349                 1>&2; exit 1; } || :;                                   \
350         else :;                                                         \
351         fi
352
353 # Require that the final line of each test-lib.sh-using test be this one:
354 # Exit $fail
355 # Note: this test requires GNU grep's --label= option.
356 sc_require_test_exit_idiom:
357         @if test -f $(srcdir)/tests/test-lib.sh; then                   \
358           die=0;                                                        \
359           for i in $$(grep -l -F /../test-lib.sh $$($(VC_LIST) tests)); do \
360             tail -n1 $$i | grep '^Exit \$$fail$$' > /dev/null           \
361               && : || { die=1; echo $$i; }                              \
362           done;                                                         \
363           test $$die = 1 &&                                             \
364             { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
365               echo 1>&2 'Exit $$fail';                                  \
366               exit 1; } || :;                                           \
367         fi
368
369 sc_the_the:
370         @re='\<the ''the\>'                                             \
371         ignore_case=1 msg='found use of "the ''the";'                   \
372           $(_prohibit_regexp)
373
374 sc_trailing_blank:
375         @re='[   ]$$'                                                   \
376         msg='found trailing blank(s)'                                   \
377           $(_prohibit_regexp)
378
379 # Match lines like the following, but where there is only one space
380 # between the options and the description:
381 #   -D, --all-repeated[=delimit-method]  print all duplicate lines\n
382 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
383 sc_two_space_separator_in_usage:
384         @grep -nE '^   *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$'         \
385             $$($(VC_LIST_EXCEPT)) &&                                    \
386           { echo "$(ME): help2man requires at least two spaces between"; \
387             echo "$(ME): an option and its description";                \
388                 1>&2; exit 1; } || :
389
390 # Look for diagnostics that aren't marked for translation.
391 # This won't find any for which error's format string is on a separate line.
392 sc_unmarked_diagnostics:
393         @grep -nE                                                       \
394             '\<error \([^"]*"[^"]*[a-z]{3}' $$($(VC_LIST_EXCEPT))       \
395           | grep -v '_''(' &&                                           \
396           { echo '$(ME): found unmarked diagnostic(s)' 1>&2;            \
397             exit 1; } || :
398
399 # Avoid useless parentheses like those in this example:
400 # #if defined (SYMBOL) || defined (SYM2)
401 sc_useless_cpp_parens:
402         @grep -n '^# *if .*defined *(' $$($(VC_LIST_EXCEPT)) &&         \
403           { echo '$(ME): found useless parentheses in cpp directive'    \
404                 1>&2; exit 1; } || :
405
406 # Require the latest GPL.
407 sc_GPL_version:
408         @re='either ''version [^3]' msg='GPL vN, N!=3'                  \
409           $(_prohibit_regexp)
410
411 cvs_keywords = \
412   Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
413
414 sc_prohibit_cvs_keyword:
415         @re='\$$($(cvs_keywords))\$$'                                   \
416             msg='do not use CVS keyword expansion'                      \
417           $(_prohibit_regexp)
418
419 # Make sure we don't use st_blocks.  Use ST_NBLOCKS instead.
420 # This is a bit of a kludge, since it prevents use of the string
421 # even in comments, but for now it does the job with no false positives.
422 sc_prohibit_stat_st_blocks:
423         @re='[.>]st_blocks' msg='do not use st_blocks; use ST_NBLOCKS'  \
424           $(_prohibit_regexp)
425
426 # Make sure we don't define any S_IS* macros in src/*.c files.
427 # They're already defined via gnulib's sys/stat.h replacement.
428 sc_prohibit_S_IS_definition:
429         @re='^ *# *define  *S_IS'                                       \
430         msg='do not define S_IS* macros; include <sys/stat.h>'          \
431           $(_prohibit_regexp)
432
433 # Each program that uses proper_name_utf8 must link with
434 # one of the ICONV libraries.
435 sc_proper_name_utf8_requires_ICONV:
436         @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
437         if test "x$$progs" != x; then                                   \
438           fail=0;                                                       \
439           for p in $$progs; do                                          \
440             dir=$$(dirname "$$p");                                      \
441             base=$$(basename "$$p" .c);                                 \
442             grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
443               || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
444           done;                                                         \
445           test $$fail = 1 &&                                            \
446             { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
447               exit 1; } || :;                                           \
448         fi
449
450 # Warn about "c0nst struct Foo const foo[]",
451 # but not about "char const *const foo" or "#define const const".
452 sc_redundant_const:
453         @re='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b'                \
454         msg='redundant "const" in declarations'                         \
455           $(_prohibit_regexp)
456
457 sc_const_long_option:
458         @grep '^ *static.*struct option ' $$($(VC_LIST_EXCEPT))         \
459           | grep -Ev 'const struct option|struct option const' && {     \
460               echo 1>&2 '$(ME): add "const" to the above declarations'; \
461               exit 1; } || :
462
463 NEWS_hash = \
464   $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
465      $(srcdir)/NEWS | grep -v '^Copyright .*Free Software' | md5sum -)
466
467 # Ensure that we don't accidentally insert an entry into an old NEWS block.
468 sc_immutable_NEWS:
469         @if test -f $(srcdir)/NEWS; then                                \
470           test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : ||              \
471             { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
472         fi
473
474 # Update the hash stored above.  Do this after each release and
475 # for any corrections to old entries.
476 update-NEWS-hash: NEWS
477         perl -pi -e 's/^(old_NEWS_hash = ).*/$${1}'"$(NEWS_hash)/" \
478           $(srcdir)/cfg.mk
479
480 epoch_date = 1970-01-01 00:00:00.000000000 +0000
481 # Ensure that the c99-to-c89 patch applies cleanly.
482 patch-check:
483         rm -rf src-c89 $@.1 $@.2
484         cp -a $(srcdir)/src src-c89
485         if test "x$(srcdir)" != x.; then \
486           cp -a src/* src-c89; \
487           dotfiles=`ls src/.[!.]* 2>/dev/null`; \
488           test -z "$$dotfiles" || cp -a src/.[!.]* src-c89; \
489         fi
490         (cd src-c89; patch -p1 -V never --fuzz=0) < $(srcdir)/src/c99-to-c89.diff \
491           > $@.1 2>&1
492         if test "$(REGEN_PATCH)" = yes; then                    \
493           diff -upr $(srcdir)/src src-c89 | sed 's,$(srcdir)/src-c89/,src/,'    \
494             | grep -vE '^(Only in|File )'                       \
495             | perl -pe 's/^((?:\+\+\+|---) \S+\t).*/$${1}$(epoch_date)/;' \
496                -e 's/^ $$//'                                    \
497             > new-diff || : ; fi
498         grep -v '^patching file ' $@.1 > $@.2 || :
499         msg=ok; test -s $@.2 && msg='fuzzy patch' || : ;        \
500         rm -f src-c89/*.o || msg='rm failed';                   \
501         $(MAKE) -C src-c89 CFLAGS='-Wdeclaration-after-statement -Werror' \
502           || msg='compile failure with extra options';          \
503         test "$$msg" = ok && rm -rf src-c89 $@.1 $@.2 || echo "$$msg" 1>&2; \
504         test "$$msg" = ok
505
506 check-AUTHORS:
507         $(MAKE) -C src $@
508
509 # Ensure that we use only the standard $(VAR) notation,
510 # not @...@ in Makefile.am, now that we can rely on automake
511 # to emit a definition for each substituted variable.
512 # We use perl rather than "grep -nE ..." to exempt a single
513 # use of an @...@-delimited variable name in src/Makefile.am.
514 makefile-check:
515         @perl -ne '/\@[A-Z_0-9]+\@/ && !/^cu_install_program =/'        \
516           -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}'    \
517             $$($(VC_LIST_EXCEPT) | grep -E '(^|/)Makefile\.am$$')       \
518           && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
519
520 news-date-check: NEWS
521         today=`date +%Y-%m-%d`;                                         \
522         if head NEWS | grep '^\*.* $(VERSION_REGEXP) ('$$today')'       \
523             >/dev/null; then                                            \
524           :;                                                            \
525         else                                                            \
526           echo "version or today's date is not in NEWS" 1>&2;           \
527           exit 1;                                                       \
528         fi
529
530 changelog-check:
531         if head ChangeLog | grep 'Version $(VERSION_REGEXP)\.$$'        \
532             >/dev/null; then                                            \
533           :;                                                            \
534         else                                                            \
535           echo "$(VERSION) not in ChangeLog" 1>&2;                      \
536           exit 1;                                                       \
537         fi
538
539 sc_makefile_TAB_only_indentation:
540         @grep -nE '^    [ ]{8}'                                         \
541             $$($(VC_LIST_EXCEPT) | grep -E 'akefile|\.mk$$')            \
542           && { echo '$(ME): found TAB-8-space indentation' 1>&2;        \
543                exit 1; } || :
544
545 sc_m4_quote_check:
546         @grep -nE '(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]'              \
547             $$($(VC_LIST_EXCEPT) | grep -E '(^configure\.ac|\.m4)$$')   \
548           && { echo '$(ME): quote the first arg to AC_DEF*' 1>&2;       \
549                exit 1; } || :
550
551 fix_po_file_diag = \
552 'you have changed the set of files with translatable diagnostics;\n\
553 apply the above patch\n'
554
555 # Verify that all source files using _() are listed in po/POTFILES.in.
556 po_file = po/POTFILES.in
557 sc_po_check:
558         @if test -f $(po_file); then                                    \
559           grep -E -v '^(#|$$)' $(po_file)                               \
560             | grep -v '^src/false\.c$$' | sort > $@-1;                  \
561           files=;                                                       \
562           for file in $$($(VC_LIST_EXCEPT)) lib/*.[ch]; do              \
563             case $$file in                                              \
564               *.?|*.??) ;;                                              \
565               *) continue;;                                             \
566             esac;                                                       \
567             case $$file in                                              \
568             *.[ch])                                                     \
569               base=`expr " $$file" : ' \(.*\)\..'`;                     \
570               { test -f $$base.l || test -f $$base.y; } && continue;;   \
571             esac;                                                       \
572             files="$$files $$file";                                     \
573           done;                                                         \
574           grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files          \
575             | sort -u > $@-2;                                           \
576           diff -u -L $(po_file) -L $(po_file) $@-1 $@-2                 \
577             || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; };   \
578           rm -f $@-1 $@-2;                                              \
579         fi
580
581 # Sometimes it is useful to change the PATH environment variable
582 # in Makefiles.  When doing so, it's better not to use the Unix-centric
583 # path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'.
584 msg = '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
585 sc_makefile_path_separator_check:
586         @grep -nE 'PATH[=].*:'                                          \
587             $$($(VC_LIST_EXCEPT) | grep -E 'akefile|\.mk$$')            \
588           && { echo $(msg) 1>&2; exit 1; } || :
589
590 # Check that `make alpha' will not fail at the end of the process.
591 writable-files:
592         if test -d $(release_archive_dir); then :; else                 \
593           for file in $(distdir).tar.gz                                 \
594                       $(release_archive_dir)/$(distdir).tar.gz; do      \
595             test -e $$file || continue;                                 \
596             test -w $$file                                              \
597               || { echo ERROR: $$file is not writable; fail=1; };       \
598           done;                                                         \
599           test "$$fail" && exit 1 || : ;                                \
600         fi
601
602 v_etc_file = lib/version-etc.c
603 sample-test = tests/sample-test
604 texi = doc/$(PACKAGE).texi
605 # Make sure that the copyright date in $(v_etc_file) is up to date.
606 # Do the same for the $(sample-test) and the main doc/.texi file.
607 sc_copyright_check:
608         @if test -f $(v_etc_file); then                                 \
609           grep 'enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' $(v_etc_file) \
610             >/dev/null                                                  \
611           || { echo 'out of date copyright in $(v_etc_file); update it' 1>&2; \
612                exit 1; };                                               \
613         fi
614         @if test -f $(sample-test); then                                \
615           grep '# Copyright (C) '$$(date +%Y)' Free' $(sample-test)     \
616             >/dev/null                                                  \
617           || { echo 'out of date copyright in $(sample-test); update it' 1>&2; \
618                exit 1; };                                               \
619         fi
620         @if test -f $(texi); then                                       \
621           grep 'Copyright @copyright{} .*'$$(date +%Y)' Free' $(texi)   \
622             >/dev/null                                                  \
623           || { echo 'out of date copyright in $(texi); update it' 1>&2; \
624                exit 1; };                                               \
625         fi
626
627 vc-diff-check:
628         $(VC) diff > vc-diffs || :
629         if test -s vc-diffs; then                               \
630           cat vc-diffs;                                         \
631           echo "Some files are locally modified:" 1>&2;         \
632           exit 1;                                               \
633         else                                                    \
634           rm vc-diffs;                                          \
635         fi
636
637 cvs-check: vc-diff-check
638
639 maintainer-distcheck:
640         $(MAKE) distcheck
641         $(MAKE) taint-distcheck
642         $(MAKE) my-distcheck
643
644
645 # Don't make a distribution if checks fail.
646 # Also, make sure the NEWS file is up-to-date.
647 vc-dist: $(local-check) cvs-check maintainer-distcheck
648         XZ_OPT=-9ev $(MAKE) dist
649
650 # Use this to make sure we don't run these programs when building
651 # from a virgin tgz file, below.
652 null_AM_MAKEFLAGS = \
653   ACLOCAL=false \
654   AUTOCONF=false \
655   AUTOMAKE=false \
656   AUTOHEADER=false \
657   MAKEINFO=false
658
659 built_programs = $$(cd src && MAKEFLAGS= $(MAKE) -s built_programs.list)
660
661 warn_cflags = -Dlint -O -Werror -Wall -Wformat -Wshadow -Wpointer-arith
662 bin=bin-$$$$
663
664 write_loser = printf '\#!%s\necho $$0: bad path 1>&2; exit 1\n' '$(SHELL)'
665
666 TMPDIR ?= /tmp
667 t=$(TMPDIR)/$(PACKAGE)/test
668 pfx=$(t)/i
669
670 # More than once, tainted build and source directory names would
671 # have caused at least one "make check" test to apply "chmod 700"
672 # to all directories under $HOME.  Make sure it doesn't happen again.
673 tp := $(shell echo "$(TMPDIR)/$(PACKAGE)-$$$$")
674 t_prefix = $(tp)/a
675 t_taint = '$(t_prefix) b'
676 fake_home = $(tp)/home
677
678 # Ensure that tests run from tainted build and src dir names work,
679 # and don't affect anything in $HOME.  Create witness files in $HOME,
680 # record their attributes, and build/test.  Then ensure that the
681 # witnesses were not affected.
682 taint-distcheck: $(DIST_ARCHIVES)
683         test -d $(t_taint) && chmod -R 700 $(t_taint) || :
684         -rm -rf $(t_taint) $(fake_home)
685         mkdir -p $(t_prefix) $(t_taint) $(fake_home)
686         GZIP=$(GZIP_ENV) $(AMTAR) -C $(t_taint) -zxf $(distdir).tar.gz
687         mkfifo $(fake_home)/fifo
688         touch $(fake_home)/f
689         mkdir -p $(fake_home)/d/e
690         ls -lR $(fake_home) $(t_prefix) > $(tp)/.ls-before
691         cd $(t_taint)/$(distdir)                        \
692           && ./configure                                \
693           && $(MAKE)                                    \
694           && HOME=$(fake_home) $(MAKE) check            \
695           && ls -lR $(fake_home) $(t_prefix) > $(tp)/.ls-after \
696           && diff $(tp)/.ls-before $(tp)/.ls-after      \
697           && test -d $(t_prefix)
698         rm -rf $(tp)
699
700 # Verify that a twisted use of --program-transform-name=PROGRAM works.
701 define install-transform-check
702   echo running install-transform-check                  \
703     && rm -rf $(pfx)                                    \
704     && $(MAKE) program_transform_name='s/.*/zyx/'       \
705       prefix=$(pfx) install                             \
706     && test "$$(echo $(pfx)/bin/*)" = "$(pfx)/bin/zyx"  \
707     && test "$$(find $(pfx)/share/man -type f|sed 's,.*/,,;s,\..*,,')" = "zyx"
708 endef
709
710 # Install, then verify that all binaries and man pages are in place.
711 # Note that neither the binary, ginstall, nor the ].1 man page is installed.
712 define my-instcheck
713   $(MAKE) prefix=$(pfx) install                         \
714     && test ! -f $(pfx)/bin/ginstall                    \
715     && { fail=0;                                        \
716       for i in $(built_programs); do                    \
717         test "$$i" = ginstall && i=install;             \
718         for j in "$(pfx)/bin/$$i"                       \
719                  "$(pfx)/share/man/man1/$$i.1"; do      \
720           case $$j in *'[.1') continue;; esac;          \
721           test -f "$$j" && :                            \
722             || { echo "$$j not installed"; fail=1; };   \
723         done;                                           \
724       done;                                             \
725       test $$fail = 1 && exit 1 || :;                   \
726     }
727 endef
728
729 define coreutils-path-check
730   {                                                     \
731     if test -f $(srcdir)/src/true.c; then               \
732       fail=1;                                           \
733       mkdir $(bin)                                      \
734         && ($(write_loser)) > $(bin)/loser              \
735         && chmod a+x $(bin)/loser                       \
736         && for i in $(built_programs); do               \
737                case $$i in                              \
738                  rm|expr|basename|echo|sort|ls|tr);;    \
739                  cat|dirname|mv|wc);;                   \
740                  *) ln $(bin)/loser $(bin)/$$i;;        \
741                esac;                                    \
742              done                                       \
743           && ln -sf ../src/true $(bin)/false            \
744           && PATH=`pwd`/$(bin)$(PATH_SEPARATOR)$$PATH   \
745                 $(MAKE) -C tests check                  \
746           && { test -d gnulib-tests                     \
747                  && $(MAKE) -C gnulib-tests check       \
748                  || :; }                                \
749           && rm -rf $(bin)                              \
750           && fail=0;                                    \
751     else                                                \
752       fail=0;                                           \
753     fi;                                                 \
754     test $$fail = 1 && exit 1 || :;                     \
755   }
756 endef
757
758 # Use -Wformat -Werror to detect format-string/arg-list mismatches.
759 # Also, check for shadowing problems with -Wshadow, and for pointer
760 # arithmetic problems with -Wpointer-arith.
761 # These CFLAGS are pretty strict.  If you build this target, you probably
762 # have to have a recent version of gcc and glibc headers.
763 # The hard-linking for-loop below ensures that there is a bin/ directory
764 # full of all of the programs under test (except the ones that are required
765 # for basic Makefile rules), all symlinked to the just-built "false" program.
766 # This is to ensure that if ever a test neglects to make PATH include
767 # the build srcdir, these always-failing programs will run.
768 # Otherwise, it is too easy to test the wrong programs.
769 # Note that "false" itself is a symlink to true, so it too will malfunction.
770 my-distcheck: $(DIST_ARCHIVES) $(local-check)
771         $(MAKE) syntax-check
772         $(MAKE) check
773         -rm -rf $(t)
774         mkdir -p $(t)
775         GZIP=$(GZIP_ENV) $(AMTAR) -C $(t) -zxf $(distdir).tar.gz
776         cd $(t)/$(distdir)                              \
777           && ./configure --disable-nls                  \
778           && $(MAKE) CFLAGS='$(warn_cflags)'            \
779               AM_MAKEFLAGS='$(null_AM_MAKEFLAGS)'       \
780           && $(MAKE) dvi                                \
781           && $(install-transform-check)                 \
782           && $(my-instcheck)                            \
783           && $(coreutils-path-check)                    \
784           && $(MAKE) distclean
785         (cd $(t) && mv $(distdir) $(distdir).old        \
786           && $(AMTAR) -zxf - ) < $(distdir).tar.gz
787         diff -ur $(t)/$(distdir).old $(t)/$(distdir)
788         -rm -rf $(t)
789         @echo "========================"; \
790         echo "$(distdir).tar.gz is ready for distribution"; \
791         echo "========================"
792
793 WGET = wget
794 WGETFLAGS = -C off
795
796 rel-check:
797         tarz=/tmp/rel-check-tarz-$$$$; \
798         md5_tmp=/tmp/rel-check-md5-$$$$; \
799         set -e; \
800         trap 'status=$$?; rm -f $$tarz $$md5_tmp; exit $$status' 0 1 2 3 15; \
801         $(WGET) $(WGETFLAGS) -q --output-document=$$tarz $(url); \
802         echo "$(md5)  -" > $$md5_tmp; \
803         md5sum -c $$md5_tmp < $$tarz
804
805 rel-files = $(DIST_ARCHIVES)
806
807 gnulib-version = $$(cd $(gnulib_dir) && git describe)
808
809 announcement: NEWS ChangeLog $(rel-files)
810         @./build-aux/announce-gen                                       \
811             --release-type=$(RELEASE_TYPE)                              \
812             --package=$(PACKAGE)                                        \
813             --prev=$(PREV_VERSION)                                      \
814             --curr=$(VERSION)                                           \
815             --gpg-key-id=$(gpg_key_ID)                                  \
816             --news=NEWS                                                 \
817             --bootstrap-tools=autoconf,automake,bison,gnulib            \
818             --gnulib-version=$(gnulib-version)                          \
819             --no-print-checksums                                        \
820             $(addprefix --url-dir=, $(url_dir_list))
821
822 ## ---------------- ##
823 ## Updating files.  ##
824 ## ---------------- ##
825
826 ftp-gnu = ftp://ftp.gnu.org/gnu
827 www-gnu = http://www.gnu.org
828
829 # Use mv, if you don't have/want move-if-change.
830 move_if_change ?= move-if-change
831
832 emit_upload_commands:
833         @echo =====================================
834         @echo =====================================
835         @echo "$(srcdir)/build-aux/gnupload $(GNUPLOADFLAGS) \\"
836         @echo "    --to $(gnu_rel_host):$(PACKAGE) \\"
837         @echo "  $(rel-files)"
838         @echo '# send the /tmp/announcement e-mail'
839         @echo =====================================
840         @echo =====================================
841
842 noteworthy = * Noteworthy changes in release ?.? (????-??-??) [?]
843 define emit-commit-log
844   printf '%s\n' 'post-release administrivia' '' \
845     '* NEWS: Add header line for next release.' \
846     '* .prev-version: Record previous version.' \
847     '* cfg.mk (old_NEWS_hash): Auto-update.'
848 endef
849
850 .PHONY: alpha beta major
851 alpha beta major: $(local-check) writable-files
852         test $@ = major                                         \
853           && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
854                || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
855           || :
856         $(MAKE) vc-dist
857         $(MAKE) news-date-check
858         $(MAKE) -s announcement RELEASE_TYPE=$@ > /tmp/announce-$(my_distdir)
859         if test -d $(release_archive_dir); then                 \
860           ln $(rel-files) $(release_archive_dir);               \
861           chmod a-w $(rel-files);                               \
862         fi
863         $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
864         echo $(VERSION) > $(prev_version_file)
865         $(MAKE) update-NEWS-hash
866         perl -pi -e '$$. == 3 and print "$(noteworthy)\n\n\n"' NEWS
867         $(emit-commit-log) > .ci-msg
868         $(VC) commit -F .ci-msg -a
869
870 .PHONY: web-manual
871 web-manual:
872         @test -z "$(manual_title)" \
873           && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
874         @cd '$(srcdir)/doc'; \
875           $(SHELL) ../build-aux/gendocs.sh -o '$(abs_builddir)/doc/manual' \
876              --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
877             "$(PACKAGE_NAME) - $(manual_title)"
878         @echo " *** Upload the doc/manual directory to web-cvs."